{************************************************************************}
{************************************************************************}
{* Modul:	adinfo.pas						*}
{************************************************************************}
{* Inhalt:	Extraktion von Zusatzinformationen fr ADir		*}
{************************************************************************}
{* Funktion:	Extraktion der Horizontal-, Vertikal- und Farb-Auflsung*}
{*		sowie Paletten- und Pack-Informationen fr Bilder,	*}
{*		Titel, Instrumentenzahl und Lnge fr Musik, Titel und	*}
{*		Betriebssystem fr Programme.				*}
{************************************************************************}
{* Version:	0.30							*}
{* Autor:	Thomas Mainka						*}
{* Datum:	30.Dez.1992						*}
{* Vernderung: Aufnahme des Datenbankformats DBF.			*}
{*		Erweiterung der Graphikformate PCX,BMP,TIFF,TGA auf	*}
{*		Truecolor-Bilder. Die Farbausgabe erfolgt in der	*}
{*		Palettenspalte.						*}
{*		Erweiterung der JPG-Auswertung fr HSI-JPEG.		*}
{************************************************************************}
{* Revision:	0.10 Erste Public Beta-Version				*}
{*		0.12 Extraktion der Routinen zur Bestimmung der Zusatz-	*}
{*		     informationen in das neue Modul adinfo.pas.	*}
{*		     Erweiterung der Graphik-Informationen um Angabe des*}
{*		     Packverfahrens.					*}
{*		     Erweiterung der Programm-Informationen auf Windows-*}
{*		     Font- und Treiber-Dateien sowie DLLs im EXE-Format.*}
{*		     Verbesserung der Datei-Typ-Erkennung durch Nutzung	*}
{*		     von Datei-Typ-Kernnungen.				*}
{*		0.14 Erweiterung der ROL-Info-Routine um die Bestimmung *}
{*		     der Anzahl der verwendeten Intrumente.		*}
{*		     Erweiterung der MOD-Info-Routine um die Bestimmung *}
{*		     der Sound-Lnge.					*}
{*		     Anpassung der WPG-Info-Routine an die Dokumentatiom*}
{*		     Erweiterung der Sound-Informationen um CMS, ORG	*}
{*		     und WAV-Dateien.					*}
{*		     Erweiterung der EXE-Infos auf True-Type FOT-Lader.	*}
{*		0.20 Weitere Verbesserung der Datei-Typ-Erkennung durch *}
{*		     Nutzung von Datei-Typ-Kennungen bei mehr Formaten. *}
{*		0.22 Aufnahme der Novell-Loadable-Module und Berck-	*}
{*		     sichtigung des genderten 32bit-Exe von OS/2 2.0.	*}
{*		     Ausnahme von Direktories mit "Extension" von der	*}
{*		     Info-Routiene (Bug-Fix von F.Decker).		*}
{* 		0.24 Korrektur falls im neuen OS/2 Linear-Exe kein Name	*}
{*		     eingetragen ist.					*}
{*		     Korrektur des Filemodes falls Datei nicht im	*}
{*		     Kompatib. Mode geffnet werden kann.		*}
{*		     Aufnahme der Packformate ARC, ZIP, ARJ und LZH.	*}
{************************************************************************}
{* Routinen:	GetCommand						*}
{*		PcxInfo							*}
{*		BmpInfo							*}
{*		WpgInfo							*}
{*		MspInfo							*}
{*		SciInfo							*}
{*		FliInfo							*}
{*		PicInfo							*}
{*		TgaInfo							*}
{*		RasInfo							*}
{*		TiffInfo						*}
{*		CutInfo							*}
{*		JpgInfo							*}
{*		GifInfo							*}
{*		LbmInfo							*}
{*		ImgInfo							*}
{*		MacInfo							*}
{*		ExeInfo							*}
{*		ComInfo							*}
{*		CmfInfo							*}
{*		CmsInfo							*}
{*		OrgInfo							*}
{*		ModInfo							*}
{*		RolInfo							*}
{*		WavInfo							*}
{*		SndInfo							*}
{*		GetInfo							*}
{************************************************************************}

unit ADInfo;
{$I-,S-}
{$M 8192,8192,655360}
interface
uses dos,adsort;
Type     Byte4     = Array[1..4] of Byte;
         TifType   = record
                       Tag: Word;
                       Typ: Word;
                       Cnt: Longint;
                       Ofs: Longint;
                     end;
         IffType   = record
                       Typ: Array[1..4] of char;
                       Len: Byte4;
                       Par: Array[1..20] of char;
                     end;
         FBufType  = record
                       case Integer of
                         0: (DummyA: Array[0..1024] of Byte;);
                         1: (GifSig: Array[1..3] of Char;
                             GifVer: Array[1..3] of Char;
                             GifLSW: Word;
                             GifLSH: Word;
                             GifPF1: Byte;
                             GifBCI: Byte;
                             GifPAR: Byte;
                             GifDum: Array[13..1024] of Char;);
                         2: (PcxCre: Byte;
                             PcxVer: Byte;
                             PcxEnc: Byte;
                             PcxBpP: Byte;
                             PcxXMi: Word;
                             PcxYMi: Word;
                             PcxXMa: Word;
                             PcxYMa: Word;
                             PcxHRe: Word;
                             PcxVRe: Word;
                             PcxPa1: Array[1..16,1..3] of Byte;
                             PcxVMo: Byte;
                             PcxPla: Byte;
                             PcxBpL: Word;
                             PcxPaI: Byte;
                             PcxDum: Array[70..1024] of Char;);
                         3: (BmpTyp: Word;
                             BmpSiz: LongInt;
                             BmpRe1: Word;
                             BmpRe2: Word;
                             BmpOff: LongInt;
                             case BmpISi: LongInt of
                               40: (BmpWid: LongInt;
                                    BmpHei: LongInt;
                                    BmpPla: Word;
                                    BmpBit: Word;
                                    BmpCom: LongInt;
                                    BmpSiI: LongInt;
                                    BmpXpM: LongInt;
                                    BmpYpM: Longint;
                                    BmpDum: Array[47..1024] of Char;);
                               20: (BmcWid: Word;
                                    BmcHei: Word;
                                    BmcPla: Word;
                                    BmcBit: Word;
                                    BmcDum: Array[31..1024] of Char;););
                         4: (LbmIff: Array[1..4] of Char;
                             LbmILe: LongInt;
                             LbmTyp: Array[1..4] of Char;
                             LbmHea: Array[1..4] of Char;
                             LbmHLe: LongInt;
                             LbmBmX: Word;
                             LbmBmY: Word;
                             LbmXPo: Word;
                             LbmYPo: Word;
                             LbmBPl: Byte;
                             LbmMas: Byte;
                             LbmPac: Byte;
                             LbmRes: Byte;
                             LbmTCo: Word;
                             LbmAsX: Byte;
                             LbmAsY: Byte;
                             LbmAuX: Word;
                             LbmAuY: Word;
                             LbmDum: Array[39..1024] of Char;);
                         5: (WpgHea: Array[1..4] of Char;
                             WpgOfs: LongInt;
                             WpgPrg: Byte;
                             WpgTyp: Byte;
                             WpgVer: Word;
                             WpgDum: Array[12..1024] of Byte;);
                         6: (GemHea: Word;
                             GemLen: Word;
                             GemBpP: Word;
                             GemLeM: Word;
                             GemSiX: Word;
                             GemSiY: Word;
                             GemPiZ: Word;
                             GemEle: Word;
                             GemDum: Array[16..1024] of Byte;);
                         7: (TifCnt: Word;
                             TifTag: Array[1..32] of TifType;
                             TifDum: Array[386..1024] of Byte;);
                        10: (CmfFId: Array[1..4] of Char;
                             CmfFFV: Word;
                             CmfOIB: Word;
                             CmfOMB: Word;
                             CmfTpQ: Word;
                             CmfCpS: Word;
                             CmfOMT: Word;
                             CmfOCN: Word;
                             CmfORe: Word;
                             CmfCTa: Array[1..16] of Byte;
                             CmfNIn: Word;
                             CmfTem: Word;
                             CmfDum: Array[40..1024] of Char;);
                        11: (VocDum: Array[0..1024] of Char;);
                        12: (ModTit: Array[0..19] of Char;
                             ModIns: Array[20..255] of Char;
                             ModPat: Byte;
                             ModTim: Byte;
                             ModPaA: Array[0..127] of Byte;
                             ModKen: Array[1..4] of Char;
                             ModRe1: Byte;
                             ModRe2: Byte;
                             ModTEf: Byte;
                             ModTPa: Byte;
                             ModDum: Array[394..1024] of Char;);
                        13: (MidDum: Array[0..1024] of Char;);
                        14: (SvxIff: Array[1..4] of Char;
                             SvxILe: LongInt;
                             SvxTyp: Array[1..4] of Char;
                             SvxHea: Array[1..4] of Char;
                             SvxHLe: Byte4;
                             SvxDum: Array[20..1024] of Char;);
                        15: (MacFst: Char;
                             MacTit: String[63];
                             MacTyp: Array[1..8] of Char;
                             MacDum: Array[73..1024] of Char;);
                        16: (RolVHi : Word;
                             RolVLo : Word;
                             RolRe1 : Array[1..40] of Byte;
                             RolTpB : Word;
                             RolBpM : Word;
                             RolXAx : Integer;
                             RolYAx : Integer;
                             RolRe2 : Byte;
                             RolPrc : Byte;
                             RolRe3 : Array[1..90] of Byte;
                             RolRe4 : Array[1..38] of Byte;
                             RolRe5 : Array[1..15] of Byte;
                             RolTem : Single;
                             RolTEv : Integer;
                             RolDum: Array[203..1024] of Char;);
                        17: (WavIff: Array[1..4] of Char;
                             WavILe: LongInt;
                             WavTyp: Array[1..4] of Char;
                             WavHea: Array[1..4] of Char;
                             WavHLe: LongInt;
                             WavFor: Word;
                             WavCha: Word;
                             WavSpS: LongInt;
                             WavMSp: LongInt;
                             WavAli: Word;
                             WavBpS: Word;
                             WavDat: Array[1..4] of Char;
                             WavDLe: LongInt;
                             WavDum: Array[48..1024] of Char;);
                        20: (ExeKen: Word;
                             ExeGlP: Word;
                             ExeGPg: Word;
                             ExeARe: Word;
                             ExeGHe: Word;
                             ExeMiP: Word;
                             ExeMaP: Word;
                             ExeSSS: Word;
                             ExeSSP: Word;
                             ExePrf: Word;
                             ExeSIP: Word;
                             ExeSCS: Word;
                             ExeSRe: Word;
                             ExeOvl: Word;
                             ExeRes: Array[28..59] of Char;
                             ExeAdN: Longint;
                             ExeDum: Array[64..1024] of Char;);
                        21: (ExnKen: Word;
                             ExnLnV: Byte;
                             ExnLnR: Byte;
                             ExnOET: Word;
                             ExnLET: Word;
                             ExnRe1: Array[1..4] of Byte;
                             ExnFl1: Word;
                             ExnADS: Word;
                             ExnGLH: Word;
                             ExnGSS: Word;
                             ExnSIP: Word;
                             ExnSCS: Word;
                             ExnSSP: Word;
                             ExnSSS: Word;
                             ExnASe: Word;
                             ExnARe: Word;
                             ExnARN: Word;
                             ExnOSe: Word;
                             ExnORe: Word;
                             ExnORN: Word;
                             ExnOMR: Word;
                             ExnOIN: Word;
                             ExnONN: LongInt;
                             ExnAVE: Word;
                             ExnAli: Word;
                             ExnARS: Word;
                             ExnFl2: Byte;
                             ExnFl3: Byte;
                             ExnAFL: Word;
                             ExnLFL: Word;
                             ExnRes: Word;
                             ExnVer: Word;
                             ExnDum: Array[64..1024] of Char;);
                        22: (ExlKen: Word;
                             ExlLnV: Byte;
                             ExlLnR: Byte;
                             ExlEFL: LongInt;
                             ExlCPU: Word;
                             ExlTOS: Word;
                             ExlMoV: LongInt;
                             ExlMoT: LongInt;
                             ExlAMP: LongInt;
                             ExlSIP: LongInt;
                             ExlSCS: LongInt;
                             ExlSSP: LongInt;
                             ExlSSS: LongInt;
                             ExlPSi: LongInt;
                             ExlBLP: LongInt;
                             ExlFSS: LongInt;
                             ExlFSC: LongInt;
                             ExlLSS: LongInt;
                             ExlLSC: LongInt;
                             ExlOOT: LongInt;
                             ExlEOT: LongInt;
                             ExlRe1: Longint;
                             ExlRe2: LongInt;
                             ExlORT: LongInt;
                             ExlERT: LongInt;
                             ExlORN: LongInt;
                             ExlOET: LongInt;
                             ExlOMD: LongInt;
                             ExlEMD: LongInt;
                             ExlRe3: LongInt;
                             ExlRe4: LongInt;
                             ExlOIM: Longint;
                             ExlEIO: LongInt;
                             ExlOPN: LongInt;
                             ExlOPC: LongInt;
                             ExlOPP: LongInt;
                             ExlAPP: LongInt;
                             ExlONN: LongInt;
                             ExlANN: LongInt;
                             ExlNNC: LongInt;
                             ExlADA: LongInt;
                             ExlODI: Longint;
                             ExlADI: LongInt;
                             ExlNPI: LongInt;
                             ExlNDI: LongInt;
                             ExlEHA: LongInt;
                             ExlDum: Array[172..1024] of Char;);
                        23: (NlmKen: Array[0..22] of Char;
                             NlmRe1: Array[0..4] of Byte;
                             NlmDat: String[12];
                             NlmRe2: Array[0..88] of Byte;
                             NlmNam: String[64];
                             NlmDum: Array[196..1024] of Char;);
                        30: (DbfKen: Byte;
                             DbfDat: Array[0..2] of Byte;
                             DbfSat: Longint;
                             DbfHSi: Word;
                             DbfSSi: Word;
                             DbfRe1: Array[0..1] of Byte;
                             DbfTra: Byte;
                             DbfCry: Byte;
                             DbfNet: Array[0..11] of Byte;
                             DbfMdx: Byte;
                             DbfRe2: Array[0..2] of Byte;
                             DbfFld: Array[32..1024] of Byte;);     
                        50: (ZipKen: Word;
                             case ZipTyp: Word of
                               $0403: (ZilVer: Word;
                                       ZilFlg: Word;
                                       ZilMet: Word;
                                       ZilLTi: Word;
                                       ZilLDa: Word;
                                       ZilCRC: Longint;
                                       ZilCSi: Longint;
                                       ZilUSi: Longint;
                                       ZilNSi: Word;
                                       ZilESi: Word;
                                       ZilDum: Array[30..1024] of Byte;);
                               $0201: (ZigVe1: Word;
                                       ZigVe2: Word;
                                       ZigFlg: Word;
                                       ZigMet: Word;
                                       ZigLTi: Word;
                                       ZigLDa: Word;
                                       ZigCRC: Longint;
                                       ZigCSi: Longint;
                                       ZigUSi: Longint;
                                       ZigNSi: Word;
                                       ZigESi: Word;
                                       ZigFSi: Word;
                                       ZigDsk: Word;
                                       ZigIFA: Word;
                                       ZigEFA: Longint;
                                       ZigOfs: Longint;
                                       ZigDum: Array[46..1024] of Byte;);
                               $0605: (ZipADs: Word;
                                       ZipDDs: Word;
                                       ZipAED: Word;
                                       ZipAET: Word;
                                       ZipDSi: Longint;
                                       ZipOfs: Longint;
                                       ZipFSi: Word;););
                        51: (ArcKen: Byte;
                             ArcTyp: Byte;
                             ArcNam: Array[0..12] of Char;
                             ArcCSi: Longint;
                             ArcDat: Word;
                             ArcTim: Word;
                             ArcCRC: Word;
                             ArcUSi: Longint;
                             ArcDum: Array[29..1024] of Byte;);
                        52: (ArjKen: Word;
                             ArjHSi: Word;
                             ArjFHS: Byte;
                             ArjAVe: Byte;
                             ArjMVe: Byte;
                             ArjHOS: Byte;
                             ArjFlg: Byte;
                             ArjMet: Byte;
                             ArjTyp: Byte;
                             ArjRes: Byte;
                             ArjDat: Longint;
                             ArjCSi: Longint;
                             ArjUSi: Longint;
                             ArjCRC: Longint;
                             ArjFPF: Word;
                             ArjFAM: Word;
                             ArjHDa: Word;
                             ArjDum: Array[34..1024] of Byte;);
                        53: (LzhHSi: Byte;
                             LzhRes: Byte;
                             LzhMet: Array[0..4] of Char;
                             LzhCSi: Longint;
                             LzhUSi: Longint;
                             LzhDat: Longint;
                             LzhDum: Array[20..1024] of Byte;);
                       100: (Dummy0: Array[0..255] of Char;
                             DummyB: Array[256..1024] of Char;);
                       101: (DumStr: String;);
                       102: (DumCh4: Array[1..4] of Char;);
                       103: (DumWrd: Word;);
                     end;

Var      Pause     : Boolean;
         D         : DirStr;
         F,F1      : File;
         FBuf      : FBufType;

Procedure GetInfo;

implementation

Function LongI(x:Byte4):Longint;
begin
   LongI:=x[4]+x[3]*256+x[2]*65536+x[1]*16777216;
end;

{************************************************************************}
{* Routine:	PcxInfo							*}
{************************************************************************}
{* Inhalt:	Extraktion von GHor, GVer, GCol und GPac fr ZSoft-PCX	*}
{* Definition:	Procedure PcxInfo;					*}
{************************************************************************}

Procedure PcxInfo;
begin
   with Dir[Count]^ do begin
     FTyp:=1;
     Kurz:='PCX'+ Char(FBuf.PcxVer+$30);
     if FBuf.PcxVer>=5 then begin
       GHor:=FBuf.PcxXMa-FBuf.PcxXMi+1;
       GVer:=FBuf.PcxYMa-FBuf.PcxYMi+1;
     end
     else begin
       GHor:=FBuf.PcxHRe;
       GVer:=FBuf.PcxVRe;
     end;
     GCol:=1 shl (FBuf.PcxBpP * FBuf.PcxPla);
     if (GCol=0) then GPal:=1 shl (FBuf.PcxBpP * FBuf.PcxPla)
     else GPal:=0;
     GPac:='   ';
     if FBuf.PcxEnc=1 then GPac:='RLE';
   end;
end;

{************************************************************************}
{* Routine:	BmpInfo							*}
{************************************************************************}
{* Inhalt:	Extraktion von GHor, GVer, GCol und GPac fr Win3-BMPs	*}
{*		sowie von GHor, GVer und GCol fr OS/2-BMPs		*}
{* Definition:	Procedure BmpInfo;					*}
{************************************************************************}

Procedure BmpInfo;
begin
   if (FBuf.BmpTyp = $4D42) then
     with Dir[Count]^ do begin
       FTyp:=1;
       GPac:='   ';
       GPal:=0;
       if FBuf.BmpISi=40 then begin
         Kurz:='BMPW';
         GHor:=FBuf.BmpWid;
         GVer:=FBuf.BmpHei;
         GCol:=1 shl (FBuf.BmpBit);
         if GCol=0 then GPal:=1 shl (FBuf.BmpBit);
         if FBuf.BmpCom>0 then GPac:='RLE';
       end
       else begin
         Kurz:='BMPO';
         GHor:=FBuf.BmcWid;
         GVer:=FBuf.BmcHei;
         GCol:=1 shl (FBuf.BmcBit);
         if GCol=0 then GPal:=1 shl (FBuf.BmcBit);
       end;
     end;
end;

{************************************************************************}
{* Routine:	RleInfo							*}
{************************************************************************}
{* Inhalt:	Extraktion von GHor, GVer, GCol und GPac fr CIS-RLEs	*}
{* Definition:	Procedure RleInfo;					*}
{************************************************************************}

Procedure RleInfo;
begin
   if ((FBuf.DummyA[0] = $1B) and (FBuf.DummyA[1] = $47)) then
     with Dir[Count]^ do begin
       FTyp:=1;
       GPac:='RLE';
       Kurz:='RLE ';
       GCol:=2;
       if FBuf.DummyA[2] = $48 then begin
         GHor:=256;
         GVer:=192;
       end
       else begin
         GHor:=128;
         GVer:=96;
       end;
       GPal:=0;
     end
   else BmpInfo;
end;

{************************************************************************}
{* Routine:	WpgInfo							*}
{************************************************************************}
{* Inhalt:	Extraktion von GHor, GVer und GCol fr WordPerf.-WPGs	*}
{* Definition:	Procedure WpgInfo;					*}
{************************************************************************}

Procedure WpgInfo;
Var      Adr,Test  : Word;
         Ad1       : Byte;

  Function WpgAdr:LongInt;
  Var    Adr1      : LongInt;
  begin
     Adr1:=FBuf.WpgDum[Adr+$1];
     Ad1:=2;
     if FBuf.WpgDum[Adr+$1]=$ff then begin
       Adr1:=FBuf.WpgDum[Adr+$2]+(FBuf.WpgDum[Adr+3] and $7f)*256;
       Ad1:=4;
       if (FBuf.WpgDum[Adr+$3] and $80)=$80 then begin
         Adr1:=Adr1*65536+FBuf.WpgDum[Adr+$2]+FBuf.WpgDum[Adr+3]*256;
         Ad1:=6;
       end;
     end;
     WpgAdr:=Adr+Adr1+Ad1;
  end;

begin
   if (FBuf.WpgHea='WPC') then
     with Dir[Count]^ do begin
       Adr:=16;
       while ((Adr<1024) and 
        ((FBuf.WpgDum[Adr]<>$0b) and (FBuf.WpgDum[Adr]<>$14))) do begin
         Adr:=WpgAdr;
         if Adr>256 then BlockRead(F1,FBuf.DummyB,768,Test);
       end;
       if (Adr<1024) then begin
         Test:=WpgAdr;
         FTyp:=1;
         Kurz:='WPG ';
         if (FBuf.WpgDum[Adr]=$0b) then begin 
           GHor:=FBuf.WpgDum[Adr+Ad1+$0]+FBuf.WpgDum[Adr+Ad1+$1]*256;
           GVer:=FBuf.WpgDum[Adr+Ad1+$2]+FBuf.WpgDum[Adr+Ad1+$3]*256;
           GCol:=1 shl (FBuf.WpgDum[Adr+Ad1+4]);
         end;
         if (FBuf.WpgDum[Adr]=$14) then begin
           GHor:=FBuf.WpgDum[Adr+Ad1+$8]+FBuf.WpgDum[Adr+Ad1+$9]*256;
           GVer:=FBuf.WpgDum[Adr+Ad1+$0a]+FBuf.WpgDum[Adr+Ad1+$0b]*256;
           GCol:=1 shl (FBuf.WpgDum[Adr+Ad1+$0c]);
         end;
         GPal:=0;
         GPac:='   ';
       end;
     end;
end;

{************************************************************************}
{* Routine:     MspInfo							*}
{************************************************************************}
{* Inhalt:	Extraktion von GHor, GVer und GCol fr MS-MSPs		*}
{* Definition:	Procedure MspInfo;					*}
{************************************************************************}

Procedure MspInfo;
begin
   if (FBuf.DumCh4='LinS') or (FBuf.DumCh4='DanM') then
     with Dir[Count]^ do begin
       FTyp:=1;
       Kurz:='MSP'+Char(FBuf.DummyA[0]);
       GHor:=FBuf.DummyA[$4]+FBuf.DummyA[$5]*256;
       GVer:=FBuf.DummyA[$6]+FBuf.DummyA[$7]*256;
       GCol:=1 shl (FBuf.DummyA[$0c]);
       GPal:=0;
       GPac:='   ';
     end;
end;

{************************************************************************}
{* Routine:     SciInfo                                                 *}
{************************************************************************}
{* Inhalt:      Extraktion von GHor und GVer fr ColoRIX-SCx		*}
{* Definition:	Procedure SciInfo;					*}
{************************************************************************}

Procedure SciInfo;
begin
   if (FBuf.DumCh4='RIX3') then
     with Dir[Count]^ do begin
       FTyp:=1;
       Kurz:='CRIX';
       GHor:=FBuf.DummyA[$4]+FBuf.DummyA[$5]*256;
       GVer:=FBuf.DummyA[$6]+FBuf.DummyA[$7]*256;
       GCol:=1;
       GPal:=0;
       GPac:='   ';
     end;
end;

{************************************************************************}
{* Routine:	FliInfo							*}
{************************************************************************}
{* Inhalt:	Extraktion von GHor, GVer und GCol fr FLIs		*}
{* Definition:	Procedure FliInfo;					*}
{************************************************************************}

Procedure FliInfo;
begin
   with Dir[Count]^ do begin
     FTyp:=1;
     Kurz:='AFLI';
     GHor:=FBuf.DummyA[$8]+FBuf.DummyA[$9]*256;
     GVer:=FBuf.DummyA[$0a]+FBuf.DummyA[$0b]*256;
     GCol:=1 shl (FBuf.DummyA[$0c]);
     GPal:=0;
     GPac:='   ';
   end;
end;

{************************************************************************}
{* Routine:	PicInfo							*}
{************************************************************************}
{* Inhalt:	Extraktion von GVor, GVer und GCol fr Pictor-PICs	*}
{* Definition:	Procedure PicInfo;					*}
{************************************************************************}

Procedure PicInfo;
begin
   if (FBuf.DumWrd=$1234) then
     with Dir[Count]^ do begin
       FTyp:=1;
       Kurz:='PIC ';
       GHor:=FBuf.DummyA[$2]+FBuf.DummyA[$3]*256;
       GVer:=FBuf.DummyA[$4]+FBuf.DummyA[$5]*256;
       GCol:=1 shl (FBuf.DummyA[$0a]);
       if GCol=0 then GCol:=16;
       GPal:=0;
       GPac:='   ';
     end;
end;

{************************************************************************}
{* Routine:	TgaInfo							*}
{************************************************************************}
{* Inhalt:	Extraktion von GHor, GVer und GCol fr TARGA-TGAs	*}
{* Definition:	Procedure TgaInfo;					*}
{************************************************************************}

Procedure TgaInfo;
begin
   with Dir[Count]^ do begin
     FTyp:=1;
     Kurz:='TARG';
     GHor:=FBuf.DummyA[$0c]+FBuf.DummyA[$0d]*256;
     GVer:=FBuf.DummyA[$0e]+FBuf.DummyA[$0f]*256;
     GCol:=1 shl (FBuf.DummyA[$10]);
     if (GCol=0) then GPal:=1 shl (FBuf.DummyA[$10])
     else GPal:=0;
     GPac:='   ';
   end;
end;

{************************************************************************}
{* Routine:	RasInfo							*}
{************************************************************************}
{* Inhalt:	Extraktion von GHor, GVer und GCol fr Sun-RASs		*}
{* Definition:	Procedure RasInfo;					*}
{************************************************************************}

Procedure RasInfo;
begin
   with Dir[Count]^ do begin
     FTyp:=1;
     Kurz:='RAS ';
     GHor:=FBuf.DummyA[$07]+FBuf.DummyA[$06]*256;
     GVer:=FBuf.DummyA[$0b]+FBuf.DummyA[$0a]*256;
     GCol:=1 shl (FBuf.DummyA[$0f]);
     GPal:=0;
     GPac:='   ';
   end;
end;

{************************************************************************}
{* Routine:	TiffInfo						*}
{************************************************************************}
{* Inhalt:	Extraktion von GHor, GVer, GCol und GPac fr TIFFs (I)	*}
{* Definition:	Procedure TiffInfo;					*}
{************************************************************************}

Procedure TiffInfo;
Var      i         : Integer;
         Adr       : Longint;
         Test      : Word;
begin
   with Dir[Count]^ do begin
     FTyp:=1;
     Kurz:='TIFF';
     GHor:=0;
     GVer:=0;
     GCol:=1;
     GPac:='   ';
     Adr:=FBuf.DummyA[$04]+Word(FBuf.DummyA[$05])*256;
     Adr:=Adr+FBuf.DummyA[$06]*65536;
     Seek(F1,Adr);
     BlockRead(F1,FBuf,1024,Test);
     GPal:=0;
     for i:=1 to FBuf.TifCnt do begin
       if FBuf.TifTag[i].Tag = $0100 then GHor:=FBuf.TifTag[i].Ofs;
       if FBuf.TifTag[i].Tag = $0101 then GVer:=FBuf.TifTag[i].Ofs;
       if FBuf.TifTag[i].Tag = $0102 then begin
         GCol:=1 shl FBuf.TifTag[i].Ofs;
         if (GCol=0) then GPal:=1 shl FBuf.TifTag[i].Ofs;
       end;
       if FBuf.TifTag[i].Tag = $0103 then 
         case FBuf.TifTag[i].Ofs of
           1: GPac:='PBi';
           2: GPac:='HUF';
           3: GPac:='Fx3';
           4: GPac:='Fx4';
           else GPac:='   ';
         end;
     end;
   end;
end;

{************************************************************************}
{* Routine:	CutInfo							*}
{************************************************************************}
{* Inhalt:	Extraktion von GHor und GVer fr Dr.Halo-CUTs		*}
{* Definition:	Procedure CutInfo;					*}
{************************************************************************}

Procedure CutInfo;
begin
   with Dir[Count]^ do begin
     FTyp:=1;
     Kurz:='CUT ';
     GHor:=FBuf.DummyA[$00]+FBuf.DummyA[$01]*256;
     GVer:=FBuf.DummyA[$02]+FBuf.DummyA[$03]*256;
     GCol:=1;
     GPal:=0;
     GPac:='   ';
   end;
end;

{************************************************************************}
{* Routine:	JpgInfo							*}
{************************************************************************}
{* Inhalt:	Extraktion von GHor, GVer und GCol fr JPEG-JPGs	*}
{* Definition:	Procedure JpgInfo;					*}
{************************************************************************}

Procedure JpgInfo;
Var      Adr,Test  : Word;
begin
   with Dir[Count]^ do begin
     FTyp:=1;
     if ((FBuf.DummyA[0]=$68) and (FBuf.DummyA[1]=$73)) then begin
       BlockRead(F1,FBuf.DummyB,768,Test);
       Adr:=2+FBuf.DummyA[14]*256+FBuf.DummyA[15];
       Kurz:='HSIJ';
     end
     else begin
       Adr:=2;
       Kurz:='JPEG';
     end;
     while ((Adr<1024) and (FBuf.DummyA[Adr+1]<>$c0)) do
       Adr:=Adr+2+FBuf.DummyA[Adr+3]+FBuf.DummyA[Adr+2]*256;
     if Adr<1024 then begin
       GHor:=FBuf.DummyA[Adr+8]+FBuf.DummyA[Adr+7]*256;
       GVer:=FBuf.DummyA[Adr+6]+FBuf.DummyA[Adr+5]*256;
       GCol:=1 shl (FBuf.DummyA[Adr+4]);
     end
     else begin
       GHor:=0;
       GVer:=0;
       GCol:=1;
     end;
     GPal:=0;
     GPac:='DCT';
   end;
end;

{************************************************************************}
{* Routine:	GifInfo							*}
{************************************************************************}
{* Inhalt:	Extraktion von GHor, GVer, GCol, GPal und GPac fr	*}
{*		Compuserve-GIFs						*}
{* Definition:	Procedure GifInfo;					*}
{************************************************************************}

Procedure GifInfo;
begin
   if (FBuf.GifSIG = 'GIF') then
     with Dir[Count]^ do begin
       FTyp:=1;
       Kurz:='G'+FBuf.GifVer;
       GHor:=FBuf.GifLSW;
       GVer:=FBuf.GifLSH;
       GCol:=1 shl ((FBuf.GifPF1 mod 8)+1);
       GPal:=1;
       GPal:=GPal shl ((((FBuf.GifPF1 div 16) mod 8)+1)*3);
       GPac:='LZW';
     end;
end;

{************************************************************************}
{* Routine:	LbmInfo							*}
{************************************************************************}
{* Inhalt:	Extraktion von GHor, GVer, GCol und GPac fr IFF-ILBMs	*}
{* Definition:	Procedure LbmInfo;					*}
{************************************************************************}

Procedure LbmInfo;
begin
   if (FBuf.LbmIff ='FORM') then
     with Dir[Count]^ do begin
       FTyp:=1;
       Kurz:='ILBM';
       GHor:=Swap(FBuf.LbmBmX);
       GVer:=Swap(FBuf.LbmBmY);
       GCol:=1 shl (FBuf.LbmBPl);
       GPal:=0;
       GPac:='   ';
       if FBuf.LbmPac=1 then GPac:='BRL';
     end;
end;

{************************************************************************}
{* Routine:	ImgInfo							*}
{************************************************************************}
{* Inhalt:	Extraktion von GHor, GVer und GCol von GEM-IMGs		*}
{* Definition:	Procedure ImgInfo;					*}
{************************************************************************}

Procedure ImgInfo;
begin
   with Dir[Count]^ do begin
     FTyp:=1;
     Kurz:='GEM ';
     GHor:=Swap(FBuf.GemPiZ);
     GVer:=Swap(FBuf.GemEle);
     GCol:=1 shl (Swap(FBuf.GemBpP));
     GPal:=0;
     GPac:='   ';
   end;
end;

{************************************************************************}
{* Routine:	MacInfo							*}
{************************************************************************}
{* Inhalt:	Identifikation von MAC-PNT und Setzen von GHor, GVer	*}
{*		und GCol						*}
{* Definition:	Procedure MacInfo;					*}
{************************************************************************}

Procedure MacInfo;
begin
   if (FBuf.MacTyp='PNTGMPNT') then
     with Dir[Count]^ do begin
       FTyp:=1;
       Kurz:='MAC ';
       GHor:=576;
       GVer:=720;
       GCol:=2;
       GPal:=0;
       GPac:='   ';
     end;
end;

{************************************************************************}
{* Routine:	DbfInfo							*}
{************************************************************************}
{* Inhalt:	Identifikation von dBase-DBF und Extraktion von DLen	*}
{*		und DSat						*}
{* Definition:	Procedure DbfInfo;					*}
{************************************************************************}

Procedure DbfInfo;
Var      Test: Word;
begin
   if ((FBuf.DbfKen and $03) = $03) then
     with Dir[Count]^ do begin
       FTyp:=4;
       Kurz:='DBF ';
       if (FBuf.DbfHSi > 256) then Blockread(F1,FBuf.DummyB,768,Test);
       DLen:=0;
       Test:=32;
       while ((Test<FBuf.DbfHSi) and (FBuf.DbfFld[Test]<>$0d) 
        and (Test<1024)) do begin
         Inc(DLen);
         Inc(Test,32);
       end;
       DSat:=FBuf.DbfSat;
     end;
end;

{************************************************************************}
{* Routine:	ExeInfo							*}
{************************************************************************}
{* Inhalt:	Extraktion von Betriebsysten, ETit, EFlg und EVer fr	*}
{*		DOS-, WIN und OS/2-EXE-Dateien (incl. Treiber+DLLs)	*}
{* Definition:	Procedure ExeInfo;					*}
{************************************************************************}

Procedure ExeInfo;
Var      Test      : Word;
         HStr      : String;
begin
   if (FBuf.ExeKen = $5A4D) then
     with Dir[Count]^ do begin
       FTyp:=2;
       Kurz:='DOS ';
       ETit:='';
       EFlg:=0;
       EVer:=0;
       if (FBuf.ExeSRe = 64) then begin
         Seek(F1,FBuf.ExeAdN);
         BlockRead(F1,FBuf,172,Test);
         if (FBuf.ExnKen=$454E) then begin
           if (FBuf.ExnFl2 = 2) then begin
             Kurz:='WIN ';
             EVer:=FBuf.ExnVer;
             EFlg:=FBuf.ExnFl3;
           end
           else if (FBuf.ExnFl2 = 1) then 
             if (FBuf.ExnFl1 and $0800)=$0800 then Kurz:='FAPI'
             else if (FBuf.ExnFl1 and $0300)=$0300 then Kurz:='PM/2'
             else Kurz:='OS/2'
           else Kurz[4]:='?';
           Seek(F1,FBuf.ExnONN);
           Blockread(F1,FBuf,256,Test);
           HStr:=FBuf.DumStr;
           if (Pos('Microsoft',HStr)<>0) and (Length(HStr)>20) then begin
             Test:=Pos('Microsoft',HStr);
             HStr:=Copy(HStr,1,Test-1) + 'MS' +
                   Copy(HStr,Test+9,Length(HStr)-Test-8);
           end;
           if (Pos('FONTRES',HStr)<>0) and (Length(HStr)>20) then begin
             Test:=Pos(':',HStr);
             HStr:='FNT:' + Copy(HStr,Test+1,Length(HStr)-Test);
           end;
           ETit:=Copy(HStr,1,20);
         end
         else if (FBuf.ExnKen=$454C) then begin
           Seek(F1,FBuf.ExlONN);
           Blockread(F1,FBuf,256,Test);
           Kurz:='W386';
           HStr:=FBuf.DumStr;
           if (Pos('Microsoft',HStr)<>0) and (Length(HStr)>20) then begin
             Test:=Pos('Microsoft',HStr);
             HStr:=Copy(HStr,1,Test-1) + 'MS' +
                   Copy(HStr,Test+9,Length(HStr)-Test-8);
           end;
           ETit:=Copy(HStr,1,20);
         end
         else if (FBuf.ExnKen=$584C) then begin
           Kurz:='OS2L';
           if FBuf.ExlONN<>0 then begin
             Seek(F1,FBuf.ExlONN);
             Blockread(F1,FBuf,256,Test);
             HStr:=FBuf.DumStr;
             ETit:=Copy(HStr,1,20);
           end;
         end;
       end;
       while Length(ETit)<20 do ETit:=ETit+' ';
     end;
end;

{************************************************************************}
{* Routine:	ComInfo							*}
{************************************************************************}
{* Inhalt:	Test auf verstecktes EXE und Identifikation als COM-Dat.*}
{* Definition:	Procedure ComInfo;					*}
{************************************************************************}

Procedure ComInfo;
begin
   if (FBuf.ExeKen=$5A4D) then ExeInfo
   else  
     with Dir[Count]^ do begin
       FTyp:=2;
       Kurz:='COM ';
       ETit:='';
       EFlg:=0;
       EVer:=0;
     end;
end;

Procedure PifInfo;
begin
end;

{************************************************************************}
{* Routine:	NlmInfo							*}
{************************************************************************}
{* Inhalt:	Extraktion von ETit fr Novell ladbare Module		*}
{* Definition:	Procedure NlmInfo;					*}
{************************************************************************}

Procedure NlmInfo;
begin
   if (FBuf.NlmKen='NetWare Loadable Module') then
     with Dir[Count]^ do begin
       FTyp:=2;
       Kurz:='NLM ';
       ETit:=Copy(FBuf.NlmNam,1,20);
       while Length(ETit)<20 do ETit:=ETit+' ';
       EFlg:=0;
       EVer:=0;
     end;
end;

{************************************************************************}
{* Routine:	CmfInfo							*}
{************************************************************************}
{* Inhalt:	Extraktion von STit und SIns fr SB-CMFs		*}
{* Definition:	Procedure CmfInfo;					*}
{************************************************************************}

Procedure CmfInfo;
Var      i         : Word;
begin
   if (FBuf.CmfFId='CTMF') then
     with Dir[Count]^ do begin
       FTyp:=3;
       Kurz:='CMF ';
       STit:='';
       if (FBuf.CmfOMT <> 0) then begin
         i:=FBuf.CmfOMT;
         while ((FBuf.CmfDum[i] <> Char($0)) and (i<FBuf.CmfOMT+20)) do begin
           STit:=STit+FBuf.CmfDum[i];
           i:=succ(i);
         end;
       while Length(STit)<20 do STit:=STit+' ';
       end;
       SIns:=FBuf.CmfNIn;
       SLen:=0;
     end;
end;

{************************************************************************}
{* Routine:	CmsInfo							*}
{************************************************************************}
{* Inhalt:	Extraktion von STit fr Gameblaster CMSs		*}
{* Definition:	Procedure CmsInfo;					*}
{************************************************************************}

Procedure CmsInfo;
Var      i         : Word;
begin
   if ((FBuf.Dummy0[0]='C') and (FBuf.Dummy0[1]='M')) then
     with Dir[Count]^ do begin
       FTyp:=3;
       Kurz:='CMS ';
       STit:='';
       i:=32;
       while ((FBuf.Dummy0[i] <> Char($0)) and (i<52)) do begin
         STit:=STit+FBuf.Dummy0[i];
         i:=succ(i);
       end;
       while Length(STit)<20 do STit:=STit+' ';
       SIns:=0;
       SLen:=0;
     end;
end;

{************************************************************************}
{* Routine:	OrgInfo							*}
{************************************************************************}
{* Inhalt:	Extraktion von STit und SIns fr Intelligent-Organ-ORGs *}
{* Definition:	Procedure OrgInfo;					*}
{************************************************************************}

Procedure OrgInfo;
Var      i         : Word;
begin
   if ((FBuf.Dummy0[0]='C') and (FBuf.Dummy0[1]='M')) then
     with Dir[Count]^ do begin
       FTyp:=3;
       Kurz:='COrg';
       STit:='';
       i:=32;
       while ((FBuf.Dummy0[i] <> Char($0)) and (i<52)) do begin
         STit:=STit+FBuf.Dummy0[i];
         i:=succ(i);
       end;
       while Length(STit)<20 do STit:=STit+' ';
       SIns:=4;
       SLen:=0;
     end;
end;

{************************************************************************}
{* Routine:	ModInfo							*}
{************************************************************************}
{* Inhalt:	Extraktion von STit, SIns und SLen fr Amiga-MODs	*}
{* Definition:	Procedure ModInfo;					*}
{************************************************************************}

Procedure ModInfo;
Var      i         : Integer;
begin
   if (FBuf.ExeKen=$5A4D) then ExeInfo
   else 
     with Dir[Count]^ do begin
       FTyp:=3;
       Kurz:='MOD ';
       STit:='';
       i:=0;
       while ((FBuf.ModTit[i]<>char($0)) and (i<20)) do begin
         STit:=STit+FBuf.ModTit[i];
         i:=i+1;
       end;
       while (Length(STit)<20) do STit:=STit+' ';
       Seek(f1,$3b6);
       Blockread(F1,FBuf.DummyB,140,i);
       if ((FBuf.ModKen='M.K.') or (FBuf.ModKen='FLT4')) then SIns:=31
       else begin
         SIns:=15;
         Seek(f1,$1d6);
         Blockread(F1,FBuf.DummyB,140,i);
       end;
       if (FBuf.ModTEf mod 16)=15 then SLen:=FBuf.ModTPa
       else SLen:=6;
       SLen:=Round(1.25*FBuf.ModPat*SLen);
     end;
end;

{************************************************************************}
{* Routine:	RolInfo							*}
{************************************************************************}
{* Inhalt:	Extraktion von SIns fr Adlib-ROLs			*}
{* Definition:	Procedure RolInfo;					*}
{************************************************************************}

Procedure RolInfo;
Type     RolFNot   = record
                       Note   : Integer;
                       Dura   : Integer;
                     end;
         RolEvnt   = record
                       Filler : Array[1..15] of Byte;
                       NumEvt : Integer;
                     end;
         RolIEvn   = record
                       TimTic : Integer;
                       InsNam : Array[1..9] of Char;
                       Reser1 : Char;
                       Reser2 : Integer;
                     end;
Var      LastI     : Integer;
         Flg       : Boolean;
         RFNot     : RolFNot;
         REvnt     : RolEvnt;
         RIEvn     : RolIEvn;
         INamen    : Array[0..100] of String[9];
         Voice     : Integer;
         i,j       : Integer;

begin
   with Dir[Count]^ do begin
     FTyp:=3;
     Kurz:='ROL ';
     STit:='';
     LastI:=0;
     Seek(f1,203+(6*FBuf.RolTEv));
     for Voice:=0 to 10 do begin
       BlockRead(f1,REvnt,17);
       while REvnt.NumEvt > 0 do begin
         BlockRead(f1,RFNot,4);
         REvnt.NumEvt:=REvnt.NumEvt - RFNot.Dura;
       end;
       BlockRead(f1,REvnt,17);
       for i:=1 to REvnt.NumEvt do begin
         BlockRead(f1,RIEvn,14);
         j:=0;
         Flg:=True;
         INamen[LastI]:=RIEvn.InsNam;
         Delete(INamen[LastI],Pos(Char(0),INamen[LastI]),9);
         while ((j < LastI) and Flg) do begin
           if INamen[j]=INamen[LastI] then Flg:=False;
           j:=Succ(j);
         end;
         if Flg then LastI:=Succ(LastI);
       end;
       BlockRead(f1,REvnt,17);
       Seek(f1,FilePos(f1)+(6*REvnt.NumEvt));
       BlockRead(f1,REvnt,17);
       Seek(f1,FilePos(f1)+(6*REvnt.NumEvt));
     end;
     SIns:=LastI;
     SLen:=0;
   end;
end;

{************************************************************************}
{* Routine:	WavInfo							*}
{************************************************************************}
{* Inhalt:	Extraktion von SIns und SLen fr MS-WAVs		*}
{* Definition:	Procedure WavInfo;					*}
{************************************************************************}

Procedure WavInfo;
begin
   if (FBuf.CmfFId='RIFF') then
     with Dir[Count]^ do begin
       FTyp:=3;
       Kurz:='WAVE';
       STit:='';
       while Length(STit)<20 do STit:=STit+' ';
       SIns:=FBuf.WavCha;
       SLen:=-Round(FBuf.WavDLe*10.0/FBuf.WavMSp);
     end;
end;

{************************************************************************}
{* Routine:	SndInfo							*}
{************************************************************************}
{* Inhalt:	Extraktion von STit fr IFF-8SVX und MAC-FSSs		*}
{* Definition:	Procedure SndInfo;					*}
{************************************************************************}

Procedure SndInfo;
Var      IffVar    : IffType;
         Adr,i     : LongInt;
begin
   with Dir[Count]^ do begin
     if (FBuf.SVXIff='FORM') then begin  
       FTyp:=3;
       Kurz:=FBuf.SvxTyp;    {'8SVX'}
       STit:='';
       Adr:=LongI(FBuf.SvxHLe)+$14;
       IffVar.Typ[1]:=' ';
       while ((Adr<256) and (IffVar.Typ<>'BODY')) do begin
         move(FBuf.SvxDum[Adr],IffVar,28);
         if (IffVar.Typ='NAME') then begin
           Adr:=1;
           while ((IffVar.Par[Adr]<>char(0)) and (Adr<20)) do begin
             STit:=STit+IffVar.Par[Adr];
             Adr:=Succ(Adr);
           end;
           while Length(STit)<20 do STit:=STit+' ';
           Adr:=2000;
         end;
         Adr:=Adr+LongI(IffVar.Len)+8;
       end;
       SIns:=0;
       SLen:=0;
     end
     else if ((FBuf.MacTyp='FSSDJOSH') or (FBuf.MacTyp='FSSDSFX!')) then
       begin
         FTyp:=3;
         Kurz:='MACS';
         STit:=Copy(FBuf.MacTit,1,20);
         while Length(STit)<20 do STit:=STit+' ';
         SIns:=0;
         SLen:=0;
       end;
   end;
end;

{************************************************************************}
{* Routine:	ArjInfo							*}
{************************************************************************}
{* Inhalt:	Extraktion von PFil und PPro fr ARJs			*}
{* Definition:	Procedure ArjInfo;					*}
{************************************************************************}

Procedure ArjInfo;
Var      GeSi,CoSi : Longint;
         Adr       : Longint;
         Anz,Test  : Word;
begin
   if (FBuf.ArjKen=$EA60) then
     with Dir[Count]^ do begin
       Adr:=0;
       GeSi:=0;
       CoSi:=0;
       Anz:=0;
       while (FBuf.ArjHSi <> 0) do begin
         Adr:=Adr+FBuf.ArjHSi+10+FBuf.ArjCSi;
         if FBuf.ArjTyp < 2 then begin
           GeSi:=GeSi+FBuf.ArjUSi;
           CoSi:=CoSi+FBuf.ArjCSi;
           Inc(Anz);
         end;
         Seek(F1,Adr);
         Blockread(F1,FBuf,256,Test);
       end;
       FTyp:=6;
       Kurz:='ARJ ';
       PFil:=Anz;
       PPro:=Round(100-((CoSi*100.0)/GeSi));
     end;
end;

{************************************************************************}
{* Routine:	ArcInfo							*}
{************************************************************************}
{* Inhalt:	Extraktion von PFil und PPro fr ARCs und PAKs		*}
{* Definition:	Procedure ArcInfo;					*}
{************************************************************************}

Procedure ArcInfo;
Var      GeSi,CoSi : Longint;
         Adr       : Longint;
         Anz,Test  : Word;

begin
   if (FBuf.ArcKen=$1a) then
     with Dir[Count]^ do begin
       Adr:=0;
       GeSi:=0;
       CoSi:=0;
       Anz:=0;
       while ((FBuf.ArcKen=$1a) and (FBuf.ArcTyp<>0)) do begin
         Adr:=Adr+FBuf.ArcCSi+29;
         GeSi:=GeSi+FBuf.ArcUSi;
         CoSi:=CoSi+FBuf.ArcCSi;
         Inc(Anz);
         Seek(F1,Adr);
         BlockRead(F1,FBuf,256,Test);
       end;
       FTyp:=6;
       if FBuf.ArcTyp <> 11 then Kurz:='ARC '
       else Kurz:='PAK ';
       PFil:=Anz;
       PPro:=Round(100-((CoSi*100.0)/GeSi));
     end;
end;

{************************************************************************}
{* Routine:	ZipInfo							*}
{************************************************************************}
{* Inhalt:	Extraktion von PFil und PPro fr ZIPs			*}
{* Definition:	Procedure ZipInfo;					*}
{************************************************************************}

Procedure ZipInfo;
Var      GeSi,CoSi : Longint;
         Adr       : Longint;
         Anz,Test  : Word;

begin
   if ((FBuf.ZipKen=$4b50) and (FBuf.ZipTyp=$0403)) then
     with Dir[Count]^ do begin
       Adr:=0;
       GeSi:=0;
       CoSi:=0;
       Anz:=0;
       while (FBuf.ZipTyp=$0403) do begin
         Adr:=Adr+FBuf.ZilCSi+FBuf.ZilNSi+FBuf.ZilESi+30;
         GeSi:=GeSi+FBuf.ZilUSi;
         CoSi:=CoSi+FBuf.ZilCSi;
         Inc(Anz);
         Seek(F1,Adr);
         BlockRead(F1,FBuf,256,Test);
       end;
       FTyp:=6;
       Kurz:='ZIP ';
       PFil:=Anz;
       PPro:=Round(100-((CoSi*100.0)/GeSi));
     end;
end;

{************************************************************************}
{* Routine:	LzhInfo							*}
{************************************************************************}
{* Inhalt:	Extraktion von PFil und PPro fr LZHs und ICEs		*}
{* Definition:	Procedure LzhInfo;					*}
{************************************************************************}

Procedure LzhInfo;
Var      GeSi,CoSi : Longint;
         Adr       : Longint;
         Anz,Test  : Word;
begin
   if ((FBuf.LzhMet[1]='l') and (FBuf.LzhMet[2]='h')) then
     with Dir[Count]^ do begin
       Adr:=0;
       GeSi:=0;
       CoSi:=0;
       Anz:=0;
       while (FBuf.LzhHSi <> 0) do begin
         Adr:=Adr+FBuf.LzhHSi+2+FBuf.LzhCSi;
         GeSi:=GeSi+FBuf.LzhUSi;
         CoSi:=CoSi+FBuf.LzhCSi;
         Inc(Anz);
         Seek(F1,Adr);
         Blockread(F1,FBuf,256,Test);
       end;
       FTyp:=6;
       Kurz:='LZH ';
       PFil:=Anz;
       PPro:=Round(100-((CoSi*100.0)/GeSi));
     end;
end;

{************************************************************************}
{* Routine:	GetInfo							*}
{************************************************************************}
{* Inhalt:	Auswahl der Info-Routine anhand der File-Extension	*}
{* Definition:	Procedure GetInfo;					*}
{************************************************************************}

Procedure GetInfo;
Var      P,Test    : Integer;
         E         : String[3];
begin
   with Dir[Count]^ do begin
     P := Pos('.', Name);
     if P > 1 then E := Copy(Name, P + 1, 3)
     else E := '';
     if (Attr and (Directory)) = 0 then begin   {Modifikat. F.Decker}
       Assign(F1,D+Name);
       Reset(F1,1);
       Test:=IOResult;
       if Test=5 then begin
         Filemode:=64;
         Reset(F1,1);
         Test:=IOResult;
         Filemode:=0;
       end;
       if Test=0 then begin
         BlockRead(F1,FBuf,256,Test);

         if E = 'GIF' then GifInfo;

         if E = 'PCX' then PcxInfo;

         if ((E = 'BMP') or (E = 'DIB')) then BmpInfo;

         if E = 'RLE' then RleInfo;

         if E = 'LBM' then LbmInfo;

         if E = 'IMG' then ImgInfo;

         if E = 'JPG' then JpgInfo;

         if E = 'MSP' then MspInfo;

         if (Copy(E,1,2) = 'SC') then SciInfo;

         if E = 'FLI' then FliInfo;

         if E = 'CUT' then CutInfo;

         if E = 'PIC' then PicInfo;

         if E = 'TGA' then TgaInfo;

         if E = 'RAS' then RasInfo;

         if E = 'WPG' then WpgInfo;

         if E = 'TIF' then TiffInfo;

         if ((E = 'MAC') or (E = 'PNT')) then
           MacInfo;

         if ((E = 'DBF') or (E = 'CAT')) then DbfInfo;

         if ((E = 'EXE') or (E = 'DLL') or (E = 'DRV') or 
             (E = 'FON') or (E = 'FOT') or (E = '386') or
             (E = 'ADD') or (E = 'IFS')) then
           ExeInfo;

         if E = 'COM' then ComInfo;

         if ((E = 'NLM') or (E = 'DSK')) then
           NlmInfo;

         if E = 'CMF' then CmfInfo;

         if E = 'CMS' then CmsInfo;

         if E = 'ORG' then OrgInfo;

         if E = 'MOD' then ModInfo;

         if E = 'ROL' then RolInfo;

         if E = 'WAV' then WavInfo;

         if ((E = 'SND') or (E = 'TUN')) then
           SndInfo;
     
         if E = 'ARJ' then ArjInfo;

         if E = 'ZIP' then ZipInfo;

         if ((E = 'ARC') or (E = 'PAK') or (E = 'SDN')) then ArcInfo;

         if ((E = 'LZH') or (E = 'ICE')) then LzhInfo;

         Close(F1);  {Mofifikation F.Decker}
       end
     end;
   end;
end;

{************************************************************************}
{* Routine:     Hauptprogramm                                           *}
{************************************************************************}
{* Inhalt:      - (keine Vorinitialisierung notwendig)                  *}
{************************************************************************}

begin
end.
